<template>
  <div class="thread">
      <div class="message-list">
        <Message v-for="msg in group.messages" :key="msg.id" :message="msg"/>
      </div>
    <MessageInput v-on:submit="submit" />
  </div>
</template>
<script lang="ts">
import Vue from 'vue';
import { mapActions, mapGetters } from 'vuex';
import MessageInput from './MessageInput.vue';
import Message from './Message.vue';
import { Group } from '@/models/Group';
import { SubmitMessageAction } from '@/store/actions';
export default Vue.component('Thread', {
  props: ['group'],
  methods: {
    submit(msg: string) {
      const message = {
        message: msg,
        date: new Date(),
      };
      this.$store.dispatch(new SubmitMessageAction({
        groupIds: [this.group.id],
        message,
      }));
    },
  },
  data: () => ({
  }),
  computed: mapGetters({

  }),
  components: {
    MessageInput,
    Message,
  },
});
</script>
<style lang="scss" scoped>
.thread {
  display: flex;
  flex-direction: column;
}
.message-list {
  display: flex;
  flex-direction: column-reverse;
  flex: 1 1 auto;
  overflow-y: scroll;
  &::-webkit-scrollbar-track {
    box-shadow: inset 0 0 6px rgba(0, 0, 0, 0.3);
    background-color: #f5f5f5;
  }

  &::-webkit-scrollbar {
    width: 6px;
    background-color: #f5f5f5;
  }

  &::-webkit-scrollbar-thumb {
    background-color: lighten(#000, 50%);
  }
}
.message {
  margin: 10px 5px;
}

.message-input {
  border-top: 1px solid lighten(#000, 80%);
  flex-basis: 50px;
}
</style>
